<template>
  <v-group>
    <v-circle :config="port.config" />
    <template v-if="port.config.displayMagnet">
      <v-line :config="tmpMagnet" />
    </template>
    <v-circle :config="{radius: port.config.radius(), x: port.config.x(), y: port.config.y()}"
      @mousedown="mousedownPort($event, port)"
      @mouseenter="setMagnetism({port, isMagnet: true})"
      @mouseleave="setMagnetism({port, isMagnet: false})"
      @mouseup="mouseup(port)"
      @dragstart="$event.cancelBubble=true"
    />
  </v-group>
</template>

<script lang="ts">
import { PortWrapper } from '@/lib/gui/wrappers/PortWrapper';
import { mapState, mapMutations } from "vuex";

export default {
  name: "GraphicPort",
  props: {
    port: PortWrapper,
  },
  computed: {
    ...mapState("connections", ["tmpMagnet", "magnetized"])
  },
  methods: {
    ...mapMutations("connections", ["setMagnetism", "setLinkStart", "validateLink"]),
    mousedownPort($event: any, port: PortWrapper) {
      this.setLinkStart(port)
      $event.cancelBubble = true;
    },
    mouseup(port: PortWrapper) {
      this.validateLink(port);
    }
  }
}
</script>